# Copyright 2020-2024 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2

EAPI=8

inherit cmake git-r3 toolchain-funcs xdg

DESCRIPTION="An emulator for Nintendo Switch"
HOMEPAGE="https://suyu.dev/"
EGIT_REPO_URI="https://git.suyu.dev/suyu/suyu"
EGIT_SUBMODULES=( '*' 'dynarmic' 'sirit' 'tzdb_to_nx' 'cpp-httplib' 'vcpkg'
	              'externals/nx_tzdb/tzdb_to_nx/externals/tz/tz' 'VulkanMemoryAllocator' 'enet' 'discord-rpc' 'RenderDoc' )
# Dynarmic is not intended to be generic, it is tweaked to fit emulated processor
# TODO wait 'xbyak' waiting version bump. see #860816

LICENSE="|| ( Apache-2.0 GPL-2+ ) 0BSD BSD GPL-2+ ISC MIT
	!system-vulkan? ( Apache-2.0 )"
SLOT="0"
IUSE="qt6 +compatibility-list +cubeb discord +qt room sdl +system-libfmt +system-vulkan lto test webengine +webservice"

RDEPEND="
	<net-libs/mbedtls-3.1[cmac]
	>=app-arch/zstd-1.5
	>=dev-libs/inih-52
	>=dev-libs/openssl-1.1:=
	>=media-video/ffmpeg-4.3:=
	>=net-libs/enet-1.3
	app-arch/lz4:=
	dev-libs/boost:=[context]
	media-libs/opus
	>=media-libs/vulkan-loader-1.3.274
	sys-libs/zlib

	virtual/libusb:1
	cubeb? ( media-libs/cubeb )
	qt? (
		dev-qt/qtcore
		dev-qt/qtgui
		dev-qt/qtmultimedia
		dev-qt/qtwidgets
		dev-qt/qtconcurrent
		dev-qt/linguist-tools
		webengine? ( dev-qt/qtwebengine )
	)
	sdl? ( >=media-libs/libsdl2-2.28 )
	system-libfmt? ( >=dev-libs/libfmt-9:= )
"
DEPEND="${RDEPEND}
	dev-cpp/cpp-httplib
	dev-cpp/cpp-jwt
	system-vulkan? ( >=dev-util/vulkan-headers-1.3.274
		dev-util/spirv-headers
		x11-libs/libX11
		dev-libs/vulkan-memory-allocator
	)
	test? ( >dev-cpp/catch-3:0 )
"
BDEPEND="
	>=dev-cpp/nlohmann_json-3.8.0
	dev-libs/xbyak
	dev-libs/stb
	dev-cpp/simpleini
	dev-cpp/robin-map
	dev-util/glslang
	discord? ( >=dev-libs/rapidjson-1.1.0 )
"
REQUIRED_USE="|| ( qt sdl ) discord? ( webservice )"
RESTRICT="!test? ( test )"

pkg_setup() {
	if tc-is-gcc; then
		[[ "$(gcc-major-version)" -lt 11 ]] && \
			die "You need gcc version 11 or clang to compile this package"
	fi
}

src_unpack() {
	if use discord; then
		EGIT_SUBMODULES+=('discord-rpc')
	fi

	if use !system-vulkan; then
		EGIT_SUBMODULES+=('Vulkan-Headers')
	fi

	if use test; then
		EGIT_SUBMODULES+=('Catch2')
	fi

	git-r3_src_unpack

	# Do not fetch via sources because this file always changes
	use compatibility-list && cp "${FILESDIR}"/compatibility_list.json > "${S}"/compatibility_list.json
}

src_prepare() {
	sed -i CMakeLists.txt -e 's/17.0.2/18.1.2/g' || die
	sed -i CMakeLists.txt -e 's/6.3.1/6.6.2/g' || die
	cmake_src_prepare
}

src_configure() {
	local -a mycmakeargs=(
		# Libraries are private and rely on circular dependency resolution.
		-DBUILD_SHARED_LIBS=OFF # dynarmic
		-DENABLE_COMPATIBILITY_LIST_DOWNLOAD=$(usex compatibility-list)
		-DENABLE_CUBEB=$(usex cubeb)
		-DENABLE_OPENSSL=OFF
		-DENABLE_LIBUSB=ON
		-DENABLE_QT=$(usex qt)
		-DENABLE_QT6=$(usex qt6)
		-DENABLE_QT_TRANSLATION=$(usex qt)
		-DENABLE_SDL2=$(usex sdl)
		-DENABLE_WEB_SERVICE=$(usex webservice)
		-DSUYU_ROOM=$(usex room)
		-DSIRIT_USE_SYSTEM_SPIRV_HEADERS=$([ use system-vulkan ] && echo OFF || echo ON)
		-DUSE_DISCORD_PRESENCE=$(usex discord)
		-DSUYU_TESTS=$(usex test)
		-DSUYU_USE_EXTERNAL_VULKAN_HEADERS=$([ use system-vulkan ] && echo ON || echo OFF)
		-DSUYU_USE_EXTERNAL_VULKAN_UTILITY_LIBRARIES=$([ use system-vulkan ] && echo ON || echo OFF)
		-DSUYU_ENABLE_LTO=$(usex lto)
		-DSUYU_USE_PRECOMPILED_HEADERS=OFF
		-DSUYU_USE_EXTERNAL_SDL2=OFF
		-DSUYU_DOWNLOAD_ANDROID_VVL=OFF
		-DSUYU_USE_FASTER_LD=OFF
		-DSUYU_CHECK_SUBMODULES=false
		-DSUYU_USE_QT_WEB_ENGINE=$(usex webengine)
		-DCMAKE_BUILD_TYPE=release
	)

	cmake_src_configure

	# This would be better in src_unpack but it would be unlinked
	if use compatibility-list; then
		mv "${S}"/compatibility_list.json "${BUILD_DIR}"/dist/compatibility_list/ || die
	fi
}
